include	\masm32\MasmBasic\MasmBasic.inc		; see below, LibMod AA

MyProc	PROTO: DWORD	; use with [url=MasmBasic.asc]MasmBasic[/url]

ShowFpu	= 0	; 3k more for two debug boxes
ShowCredits	= 0
usedeb	= 1	; about 1k more
ShowRes	= 0
WaitKey	= 1	; simulate more

; Usage: dummy 123, int 3 - type olly to get the ExternDef code
dummy MACRO arg, args:VARARG
  mov f2sOlly, arg
ENDM

dm MACRO atarg		; debug macro for testing stack and ecx
	.if ecx!=esp
		mov eax, esp
		sub eax, ebx
			pushad
			invoke MessageBox, 0, str$(eax), chr$("Stack at &atarg&"), MB_OK
			popad
		mov ecx, esp	; heal it
	.endif
ENDM

.data?
gChar0	dd ?
MyPos	dd ?
A$	dd ?
B$	dd ?
C$	dd ?

.data
MyR4	REAL4	123444.4444
MyR8	REAL8	123456.7890
MyR10	REAL10	123456.7890
MyInt32	dd	1234567890
MyPI_low	REAL10	3.14159
; MyPI_low	dd 	3   ; you can use dwords, real4/8/10, reg32

MyPI_hi	REAL4	3.14160
MyPIexact	REAL10	3.1415926535897932384626

fsusg	db "GetFiles filter [, startpattern] [, endpattern] [, mode]", 0

MyQ	dq 1234567

.code
		; int 3 ; OPT_Olly 2
start:		invoke SetConsoleOutputCP, 1252		; user must set console properties to Lucida Console
		crtbuf ThisExe$, MAX_PATH				; give me a string in the uninitialised data section
		invoke GetModuleFileName, 0, ThisExe$, MAX_PATH	; eax returns # of bytes copied not incl. null
		mov ecx, esp				; we test the stack, and if ecx is preserved
		Print "Float comparisons:", CrLf$
		Fcmp MyPI_hi, PI, medium
			.if Carry?
				Print Str$("MyPI_hi \tat %f is lower than the real PI\n", MyPI_hi)
			.elseif Zero?
				Print Str$("MyPI_hi \tat %f is exact\n", MyPI_hi)
			.else
				Print Str$("MyPI_hi \tat %f is higher than the real PI\n", MyPI_hi)
			.endif
			NoProcs = 0
			Fcmp MyPIexact, PI, top
			.if Carry?
				Print Str$("MyPIexact \tat %f is lower than the real PI\n", MyPIexact)
			.elseif Zero?
				Print Str$("MyPIexact \tat %Jf is exact\n", MyPIexact)
			.else
				Print Str$("MyPIexact \tat %f is higher than the real PI\n", MyPIexact)
			.endif
			Fcmp MyPI_low, PI, medium
			.if Carry?
				Print Str$("MyPI_low \tat %f is lower than the real PI\n", MyPI_low)
			.elseif Zero?
				Print Str$("MyPI_low \tat %f is exact\n", MyPI_low)
			.else
				Print Str$("MyPI_low \tat %f is higher than the real PI\n", MyPI_low)
			.endif
			Print "New: Assigning to Left$/Mid$/Right$", CrLf$
		Let esi="This is a test of the new Mid$=function: TEST"
		push ecx	; Stack?
		mov ecx, 11
		Let Mid$(esi, ecx, 4)=Mid$(esi, 42)+" but don't overwrite the buffer, right?"+CrLf$
		Print CrLf$, "The first result:", Tb$, "[", esi, "]"
		Let Mid$(esi, ecx)=Mid$(esi, 42)+" but don't overwrite the buffer, right?"+CrLf$
		Print CrLf$, "The second result:", Tb$, "[", esi, "]", CrLf$
		pop ecx
	; compare a local copy of windows.inc against the original; only difference,
	; at the very end: "echo Warning" instead of "echo WARNING"
	test eax, FilesDiffer("Windows.inc", "\masm32\include\windows.inc", 1)	; 1=case-insensitive
	.if Zero?
			Print "Files are equal, case-insensitive", CrLf$
		.else
		mov MyPos, edx	; edx trashed by first Str$
			Print Str$("Files differ by %i", eax), Str$(" at pos %i, case-sensitive\n", MyPos)
		.endif
	.if FilesDiffer("Windows.inc", "\masm32\include\windows.inc")		; 0 or no arg: case-sensitive
		mov MyPos, edx	; edx trashed by first Str$
			Print Str$("Files differ by %i", eax), Str$(" at pos %i, case-sensitive\n", MyPos)
		.else
			Print "Files are equal", CrLf$
		.endif
	; string comparison:
	if 1
	MovVal f:xmm3, Chr$("12345678.12345678") ; fix ChkNum
	Print Str$("xmm3 in:\t%Hf\n", f:xmm3)
	endif
;	mov f2sOlly, 99

	test eax, StringsDiffer("WinDows.inc", "windows.inc", 1)	; 1=case-insensitive
	.if Zero?
		PrintLine "Strings are equal, case-insensitive (OK)"
	.else
		mov MyPos, edx	; edx trashed by first Str$
		Print Str$("Strings differ by %i", eax), Str$(" at pos %i, ci\n", MyPos)
	.endif
;	.listall
	; error A2008:syntax error : push reparg_offset("windows.inc")
	.if StringsDiffer("windows.Inc", "windows.inc")		; 0 or no arg: case-sensitive
		mov MyPos, edx	; edx trashed by first Str$
			Print Str$("Strings differ by %i", eax), Str$(" at pos %i (pos 8 expected)\n", MyPos)
		.else
			Print "Strings are equal (expected: pos 8)", CrLf$
		.endif
	Print Str$("xmm3 out:\t%Hf\n", f:xmm3)
ife NoProcs
	call CharTest		; ABC: test the Chr$ macro    v v JWasm 2.05 chokes here
				Print "The drive is ", Left$(ThisExe$, Instr_(ThisExe$, "\")-1), ", \
				and this executable sits in ", Left$(MbExeFolder$, Rinstr(MbExeFolder$, "\")-1), CrLf$
				Print "File creation date & time: ", CrtDate$, ", ", CrtTime$, Str$(", %3f hours since last boot", Timer/1000/3600), CrLf$, CrLf$	; Basic is simple ;-)
				Print String$(49-10, "+x")
				Print CrLf$,     "        |        Trim a string        |",13, 10
				Print "LTRIM$: |", Ltrim$("        Trim a string        "), "|",CrLf$
				Print "RTRIM$: |", Rtrim$("        Trim a string        "), "|",CrLf$
				Print "TRIM$:  |",  Trim$("        Trim a string        "), "|",CrLf$, CrLf$

	Print "[* Left, Mid, Right$:]", CrLf$
	repct=0
	REPEAT 2		; 150 Bytes for 3 tmp$s, 50/Print, of which only 16 to the X$ call
					repct=repct+1
					tmp$ CATSTR <Print Left$("[Left$>, %repct, <_is great", 8)>			; [Left$1_is great
					tmp$
					tmp$ CATSTR <Print Mid$("This Mid$>, %repct, <_algo is great", 6, 6)>	; This Mid$1_algo is great
					tmp$
					tmp$ CATSTR <Print Right$("And the fantastic Right$>, %repct, <]", 8)>	; fantastic Right$1]
					tmp$
					Print
				ENDM
				Print CrLf$, Replace$("A square made with 4 nested For...Next loops:", "4", "three")
				m2m eax, 4
				push ecx
				mov ecx, eax
				For_ n1=eax To eax+3		; 4 rows
					Print
					For_ n2=0 To ecx-1		; 4 #
						Print "#"
						For_ n3=ecx+2 To ecx-1	; one each (for is non-rejecting)
							Print "*"
						Next
					Next n2
				Next
				pop ecx
	if 1			; choked with JWasm
				MovVal MyR10, chr$(9, "  -123.45678901234567890e-123 cute?")
	else
				invoke MbVal, chr$("1234"), offset MyR10, 0
	endif
				Print Str$("\nMovVal MyR10, chr$(9,'-123.45678901234567890e-123')=%Jf\n", MyR10)
				Print String$(0, 0), CrLf$, CrLf$	; String$(0, x) means repeat last result
				Open "I", #1, ThisExe$
				mov ebx, Lof(#1)
				Close
				if WaitKey
				Inkey "One more page (press 'n' to exit)?", Cr$	; MasmBasic Inkey does not trash ecx
				.if al=="n"
					Exit "n1"
				.else
					Print String$(80," "), Cr$
				.endif
				endif
				; Delete Files$(2)		; RT error, GPF: Count too high = not yet filled (Jwasm gives wrong line)
				; Delete NoSuchFiles$(3)	; AT error: undefined array
;				mov f2sOlly, 123
;				int 3
	GetFiles \Masm32\include\*.inc, "rect struct", "ends", 9	; LetBug
				.if eax
						Print "The line",CrLf$,CrLf$,"GetFiles \Masm32\include\*.inc, ", '"rect struct"', ", ",'"ends"',", 9", CrLf$,\
						CrLf$, "returned in Files$(1) and Files$(2) the following matches:",CrLf$,CrLf$, Files$(1), CrLf$, CrLf$, Files$(2), CrLf$, CrLf$
						; split here because JWasm had a problem with the joint line; Mid(5)=cut off the "it's a file" flag (SpTbSpSp)
						Print "Found in: ", Tb$, Mid$(Files$(0), 5), CrLf$,"Usage:     ", Tb$, addr fsusg
						Print CrLf$, String$(30, "-"), Str$("\nThis file has only %3f kBytes\n",ebx/1024)
	.endif
	invoke MyProc, 123
	mov eax, 12345	; test if clv preserves eax
	call TestCLV	; test ClearLocalVariables uses edi esi ebx, PopUses
	SendData "MyClient", "Ciao Jochen"		; needs a client window called "MyClient"
	Print Chr$(13, 10, 10, "Open browser window: ")
	.if WinByTitle("- Mozilla", 4)	; optional bit mask: 0+1 for case-insensitive search, +4 for any position in title; e.g. 5 finds also - moZilla
		Print Win$(eax), 13, 10
	.else
		Print "none", 13, 10
	.endif
	if ShowFpu
		call FpuTest	; two debug boxes
	endif
	Print Str$("\nPI = %Jf", PI)
	mov eax, 2000000000	; 2e9
	;mov ecx, eax		; Str$(ecx*eax) works fine because ecx does not trash eax
	mov edx, eax
	Print Str$(", eax=2.0e9, edx=eax, eax*edx = %i", eax*edx)	; edx and immediate reals trash eax, therefore eax first; ecx*eax is OK
	push ecx
	mov eax, 123456789
	mov ecx, eax
	mov edx, 1000000000
	mul edx
	Print Str$("\nmov eax, 123456789; mov ecx, eax; mov edx, 1000000000; mul edx:\nedx::eax+ecx=%i", edx::eax+ecx)
	pop ecx
				if WaitKey
				Inkey "   - one more (press 'n' to exit)?", CrLf$	; MasmBasic Inkey does not trash ecx
				.if al=="n"
					Exit "n1"
				.endif
				endif
	Dim My$(2,2)	; 9 elements
	Let My$(2, 2)="ARRAY: This is array element 2, 2 or 8"
	Print "My$(2,2)=[", My$(2,2), "]", CrLf$
	Insert My$(1, 1)
	Print "My$(2,2)=[", My$(2,2), "] (1,1 inserted, so 2,2 is old empty 1,1)", CrLf$
	Delete My$(1, 1)
	Print "My$(2,2)=[", My$(2,2), "] (1,1 deleted, 2,2 is back)", CrLf$
	Print "My$(8)=[", My$(8), "] (=2,2 as single index)", CrLf$
	Dim My$(new:8)	; 9 elements
	Print "My$(8)=[", My$(8), "] (Redim, new string is empty)"
	Let My$(3)="ARRAY: This is an array element"
	Let Left$(My$(3), 5)="Hello"		; valid syntax also for Mid$ and Right$
	Print CrLf$, "An array: My$(3)=", My$(3)
	mov esi, Chr$("Ths is  TST")
	Print CrLf$, "Test Upper$/Lower$ - requires Lucida Console: ", CrLf$, esi, CrLf$, Lower$(esi), CrLf$, Upper$(esi)
	GetFiles win*.inc|*.asm			; fill the Files$() array with *.inc and *.asm files of the current directory
	push eax
	Swap Files$(), My$()
	Print CrLf$, "M0", Tb$, My$(0), CrLf$
	Print "M1", Tb$, My$(1), CrLf$
	Print "M2", Tb$, My$(2), CrLf$
	Swap Files$(), My$()
	Print Str$("\nFound %i files matching win*.inc/*.asm (we show only 10):", [esp])
	ConsoleColor cDarkRed, cYellow
	pop eax
	For_ n=0 To Min(9, eax-1)	; rv in edx eax-1
					m2m ebx, 41
					sub ebx, Len(Files$(n))
					Print CrLf$, Str$("%i bytes\t", Lof(Files$(n))), Files$(n), Space$(ebx)
				Next
	ConsoleColor		; back to default
				if ShowCredits
					Credits
				endif
				Let A$=New$(100)
				mov B$, chr$("Swap strings: This is B")
				mov C$, chr$("Swap strings: This is C")
				Swap C$, B$
				Print CrLf$, "C$=", C$
				Swap C$, B$
				Print CrLf$, "C$=", C$
				For_ ebx=0 To 999
					Let Files$(ebx)=String$(32767-ebx, Chr$(ebx))		; 1000*32787=32 Megabytes
				Next
				Bmove chr$("This text was bmoved into a String$(32767) in Files$('A')"), Files$('A')
				Print CrLf$, Left$(Files$(65), 60)
				invoke MbCopy, A$, chr$(13, 10, "These are xx"), 12
				Open "O", #1, "A_string.txt"
				Print #1, "some bits and pieces"
				Close
				Let edi=New$(100)
				Bmove chr$(" read from a file"), edi
				Let esi=A$+FileRead$("A_string.txt")+edi+Str$(": %i bytes", Lof("A_string.txt"))	;+", hex="+Hex$(1a2b3c4dh)+"h"
				Print esi
;				Print ", Hex$(12345678h)=", Hex$(12345678h)
	Clr$ A$		; assign empty string
	Delete A$		; delete it
	Clr$ My$(0)	; assign empty string
	Delete My$(0)	; delete it
	Dim My$(new:1000, 250)
	Let My$(1000, 250)=CrLf$+"This is array element My"+"$(1000, 250)"+CrLf$	; split is needed to prevent expansion
	Print My$(1000, 250)
	Print Str$("The PopCount of 11110000101010101111000010101010b is %i\n",\
	PopCount(11110000101010101111000010101010b))
	Print Str$("33.33% of the file size is %f\n", f8Percent(Lof(ThisExe$), 33.33))
	Rand()	; initialise
	Print Str$("Blazing fast and versatile RNG with excellent randomness, e.g. Rand(1000)=%i\n", Rand(1000))
			;	Let eax=FileRead$("test.txx")	; Could not open
			;	void FileRead$("test111.txx")
	Kill "A_string.txt"
	if 0
		Let edx="A_string.txt"
		Kill edx
		Print CrLf$, LastError$()	; could not find, already killed...
	endif
	.if ecx!=esp
		deb 1, "Stack", ecx, esp
	.else
		print " Stack test OK"
	.endif
;	Print cStyle$("\nHow\nare\nyou?")
;	MsgBox 0, cStyle$("How\nare\nyou?"), "Hi", MB_OK

FLOATSTRUC STRUCT
f4	REAL4 ?
f8	REAL8 ?
f10	REAL10 ?
fsrect	RECT <?>
filler	WORD ?
FLOATSTRUC ENDS
	Dim MyFloats(5) As FLOATSTRUC		; Create an array of structures in heap memory, with 5 elements
	fldpi		; push PI on the FPU (3.14159265358979324)
	fst MyFloats(3, f4)		; load PI into the REAL4 and REAL8 members
	fst MyFloats(3, f8)
	fstp MyFloats(3, f10)		; load PI into the REAL10 member, and pop ST
	Let MyFloats(4)=MyFloats(3)		; copy array element #3 into array element #4
	Print Str$("\nTesting structures:\nResult 4, f10=%If\n", MyFloats(4, f10))	; show the result (%If means full precision; use 0...9, A...I)
	MovVal MyFloats(4, f10), chr$("123.456e97")	; convert an Ascii string, and move it directly into array member #4, f10 (the REAL10 member)
	Print Str$("Result 4, f10=%f\n", MyFloats(4, f10))	; show the result (%f means default precision)
	Let MyFloats(0)=MyFloats(4)		; copy array element #4 into array element #0
	push esi		; your responsibility to preserve esi
	MyFloats(4:esi)		; from now on, use esi for array element #3 - same as ASSUME
	fld MyFloats(f8)		; push the REAL8 member onto the FPU
	fstp MyFloats(f10)		; load the value into the REAL10 member, and pop ST
	void MyFloats(f10)		; do nothing, OK
	void Str$("Result ?, f10=%f\n", MyFloats(f10))	; OK
	Print Str$("Result ?, f10=%f\n", MyFloats(f10))	; OK
	Print Str$("Result 4, f10=%f\n", MyFloats(4, f10))	; OK
	MyFloats(4:none)		; release esi, back to normal mode (where edx is used for every call)
	pop esi		; restore esi
	Print Str$("Result 0, f10=%f\n", MyFloats(0, f10))	; show the results for three array members and their REAL10 elements
	Print Str$("Result 3, f10=%f\n", MyFloats(3, f10))
	Print Str$("Result 4, f10=%f", MyFloats(4, f10))
	;Print Str$("\nMbMacSlot=%i", MbMacSlot)
	if ShowRes
		Print CrLf$, "If it hangs here, check taskbar for 'Unicode', and if OP", "T_Res 0 is disabled", CrLf$
		pushad
		invoke MessageBoxW, 0, wRes$(100), wChr$("Unicode is great:"), MB_OK	; see opt_res below
		popad
	endif
	Inkey Str$("\nThat was cute for %3f kBytes, right? Hit space to get outta here", Lof(ThisExe$)/1024)
endif
	Exit debug	; Exit, not exit, cleans up the heap
ife NoProcs
MyProc proc ciao:DWORD
LOCAL v1:DWORD, v2:DWORD, pos, posAfter, MyTimer, MyCounter
ClearLocalVariables uses edi esi ebx
  mov eax, ciao
  mov v1, eax
  m2m v2, 456
  Print Str$("\nMyProc: v1 = %i", v1), Str$(", v2 = %i", v2)
  Print " testing z$: ", z$(Left$("Test", 3)), "t", CrLf$

  	mov MyTimer, Timer
	Recall "\Masm32\include\Windows.inc", L$()		; convert Windows.inc (twice as fast as VB, 10*Gfa)
	mov ebx, eax
	For_ n=0 To eax-1
		mov pos, Instr_(1, L$(n), "equ", 5)			; start in pos 1, 1=case-insensitive + 4=full word
		.if pos
			mov esi, Val(Mid$(L$(n), pos+3, 99))
			.if dh										; binary or hex
				.if edx!=-127							; -127 is the "doubtful" flag, we ignore it here
					.if dh==1							; if dh is set to 1, it was a binary string, otherwise hex
						deb 1, "Found a binary value in Windows.inc", $L$(n)
						movzx edx, dl
					.endif
					movzx edx, dl					; binary strings return usable chars in dl, plus a flag in dh
					add edx, pos
					add edx, 3
					mov posAfter, edx
					inc MyCounter
					Let L$(n)=Left$(L$(n), pos-1)+Str$("EQU %i", esi)+Mid$(L$(n), posAfter)	;+Str$("x%i", ebx)
				.endif
			.endif
		.endif
	Next
	; Insert L$(L$(?)) count too high...
	Insert L$(0)
	Let L$(0)="echo ####### Thank you for using the modified version of Windows.inc #######"
	Store "MyWindows.inc", L$()			; write all strings to file
	sub MyTimer, Timer
	Print Str$("\nConverting %i hex equates in Windows.inc to decimals", MyCounter), Str$(" took %i ms\n", 0-MyTimer)
	; Launch "\masm32\RichMasm\RichMasm.exe MyWindows.inc"
	Clr MyTimer
	Print <'Print Mid$(Str$(Str$("A test: %i%i", 123), 456), 10, 4), CrLf$: '>
	Print Mid$(Str$(Str$("A test: %i%i", 123), 456), 10, 4), CrLf$	; yields 2345: A test: 123456
	mov ebx, Val(Str$(12*34-8))
	Print Str$("Simple calculations with mov reg, Val(Str$(...)): mov ebx, 12*34-8  ebx=%i", ebx)
  PopUses
  ret
MyProc endp

CharTest proc
LOCAL Lv1:DWORD, Lv2:BYTE
  mov eax, "a"
  mov gChar0, "b"
  mov Lv1, "c"
  mov Lv2, "d"
  Print Chr$("Chr$ accepts registers: ", eax, ", global: ", gChar0, " and local DWORD: ", Lv1, " or BYTE: ", Lv2, " variables")
  mov ebx, "A"
  Print CrLf$, "######### The alphabet from a loop: "
  .Repeat
	Print Chr$(ebx+32)
  	inc ebx
  .Until ebx>"Z"
  Print
  ret
CharTest endp

TestCLV proc
LOCAL v1, v2, rc:RECT
ClearLocalVariables uses edi esi ebx
  .if eax!=12345
	MsgBox 0, "ClearLocalVariables trashed eax!", "Surprise:", MB_OK
  .else
	if 0
.data
	MyDest	db "Dest is short", 0
	MySrc		db "MbCopy is OK but too long", 0
.code
	invoke MbCopy, offset MyDest, offset MySrc, SIZEOF MyDest-1	; -1 as last arg would use source len!
  	Print CrLf$, offset MyDest
	endif
  .endif
PopUses
ret
TestCLV endp
endif	; NoProcs end

if ShowFpu
FpuTest proc
	finit
	push eax	; create a stack slot
	mov dword ptr [esp], 100007
	fild dword ptr [esp]
	dec dword ptr [esp]
	fild dword ptr [esp]
	dec dword ptr [esp]
	fild dword ptr [esp]
	dec dword ptr [esp]
	fild dword ptr [esp]
	dec dword ptr [esp]
	fild dword ptr [esp]
	dec dword ptr [esp]
	fild dword ptr [esp]
	dec dword ptr [esp]
	fild dword ptr [esp]
	dec dword ptr [esp]
	fild dword ptr [esp]
	pop eax		; release stack slot
	push ecx
	mov ecx, chr$("FPU registers:")
	MyEq = 123
	deb 1, "Testing the FPU, first box:", MyR4, MyR8, MyR10, MyInt32, $ecx, ST(0), ST(1), ST(2), ST(3), ST(4), ST(5), ST(6), ST(7)
	MyEq = 456
	deb 1, "Testing the FPU, second box:", eax, ax, al, MyEq, $ecx, ST(0), ST(1), ST(2), ST(3), ST(4), ST(5), ST(6), ST(7)
	pop ecx
	ret
FpuTest endp
endif

end start
